CREATE TABLE [Account](
    [ID] [int] IDENTITY(1,1) NOT NULL,
    [Name] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_Account] PRIMARY KEY ([ID]),
 CONSTRAINT [IX_Account] UNIQUE ([Name])
);
GO

CREATE TABLE [Company](
    [ID] [int] IDENTITY(1,1) NOT NULL,
    [Name] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_Company] PRIMARY KEY ([ID]),
 CONSTRAINT [IX_Company] UNIQUE ([Name])
);
GO

CREATE TABLE [Item](
    [ID] [int] IDENTITY(1,1) NOT NULL,
    [Name] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_Item] PRIMARY KEY ([ID]),
 CONSTRAINT [IX_Item] UNIQUE ([Name])
);
GO

CREATE TABLE [Payment](
    [ID] [int] IDENTITY(1,1) NOT NULL,
    [Date] [datetime] NULL,
    [Sum] [money] NULL,
    [AccountID] [int] NULL,
    [CompanyID] [int] NULL,
    [ItemID] [int] NULL,
    [Comment] [nvarchar](50) NULL,
 CONSTRAINT [PK_Payment] PRIMARY KEY ([ID])
);
GO

ALTER TABLE [Payment] ADD CONSTRAINT [FK_Payment_Account] FOREIGN KEY([AccountID])
REFERENCES [Account] ([ID])
ON UPDATE CASCADE;
GO

ALTER TABLE [Payment] ADD CONSTRAINT [FK_Payment_Company] FOREIGN KEY([CompanyID])
REFERENCES [Company] ([ID])
ON UPDATE CASCADE;
GO

ALTER TABLE [Payment] ADD CONSTRAINT [FK_Payment_Item] FOREIGN KEY([ItemID])
REFERENCES [Item] ([ID])
ON UPDATE CASCADE;
GO
