@echo off

rem Setting the path to gsqlcmd.exe

set gsqlcmd=gsqlcmd.exe
if exist ..\gsqlcmd\gsqlcmd.exe         set gsqlcmd=..\gsqlcmd\gsqlcmd.exe
if exist ..\..\gsqlcmd\gsqlcmd.exe      set gsqlcmd=..\..\gsqlcmd\gsqlcmd.exe
if exist ..\..\..\gsqlcmd\gsqlcmd.exe   set gsqlcmd=..\..\..\gsqlcmd\gsqlcmd.exe

rem Reading the application name from label.txt

if exist label.txt @for /F "delims==" %%i in (label.txt) do set label=%%i

if "%label%"=="" set label=the example application

rem Verifying the main file

if not exist application-install.sql goto NO_INSTALL_SQL



choice /C yn /M "Continue to INSTALL %label%"

if errorlevel 2 goto END


rem If framework-check.cmd exists then the file is called to verify that the framework has been installed

if exist framework-check.cmd call framework-check.cmd


rem Executing the installation code

if exist application-install.sql        %gsqlcmd% setup application-install.sql     /inputcodepage=65001

if errorlevel 1 goto END


rem Executing the translation code

if exist application-translation.sql    %gsqlcmd% setup application-translation.sql /inputcodepage=65001 /notransaction

if errorlevel 1 goto END


rem Executing the code to setup grants

if exist application-grants.sql         %gsqlcmd% setup application-grants.sql      /inputcodepage=65001 /notransaction

if errorlevel 1 goto END


rem Printing application objects

echo.

if exist application-list.sql           %gsqlcmd% setup application-list.sql        /inputcodepage=65001 /notransaction /addrownum

goto END


:NO_INSTALL_SQL

echo The required file application-install.sql does not exist
exit


:END
