﻿SELECT
    NULL AS [JobTitle]
    , CASE WHEN n.ID IS NOT NULL THEN n.FirstName ELSE t.FirstName END AS [First Name]
    , NULL AS [Middle Name]
    , CASE WHEN n.ID IS NOT NULL THEN n.LastName ELSE t.LastName END AS [Last Name]
    , NULL AS [Suffix]
    , CASE WHEN y.ID IS NOT NULL THEN y.Company ELSE t.Company END AS [Company]
    , NULL AS [Department]
    , CASE WHEN i.ID IS NOT NULL THEN i.JobTitle ELSE t.JobTitle END AS [Job Title]
    , NULL AS [Business Street]
    , NULL AS [Business Street 2]
    , NULL AS [Business Street 3]
    , NULL AS [Business City]
    , NULL AS [Business State]
    , NULL AS [Business Postal Code]
    , COALESCE(r.Country, rs.CountryName) AS [Business Country/Region]
    , NULL AS [Home Street]
    , NULL AS [Home Street 2]
    , NULL AS [Home Street 3]
    , NULL AS [Home City]
    , NULL AS [Home State]
    , NULL AS [Home Postal Code]
    , NULL AS [Home Country/Region]
    , NULL AS [Other Street]
    , NULL AS [Other Street 2]
    , NULL AS [Other Street 3]
    , NULL AS [Other City]
    , NULL AS [Other State]
    , NULL AS [Other Postal Code]
    , NULL AS [Other Country/Region]
    , NULL AS [Assistant''s Phone]
    , NULL AS [Business Fax]
    , CASE WHEN p.ID IS NOT NULL THEN p.Phone ELSE t.Phone END AS [Business Phone]
    , NULL AS [Business Phone 2]
    , NULL AS [Callback]
    , NULL AS [Car Phone]
    , NULL AS [Company Main Phone]
    , NULL AS [Home Fax]
    , NULL AS [Home Phone]
    , NULL AS [Home Phone 2]
    , NULL AS [ISDN]
    , CASE WHEN m.ID IS NOT NULL THEN m.Mobile ELSE t.Mobile END AS [Mobile Phone]
    , NULL AS [Other Fax]
    , NULL AS [Other Phone]
    , NULL AS [Pager]
    , NULL AS [Primary Phone]
    , NULL AS [Radio Phone]
    , NULL AS [TTY/TDD Phone]
    , NULL AS [Telex]
    , NULL AS [Account]
    , NULL AS [Anniversary]
    , NULL AS [Assistant''s Name]
    , NULL AS [Billing Information]
    , NULL AS [Birthday]
    , NULL AS [Business Address PO Box]
    , NULL AS [Categories]
    , NULL AS [Children]
    , NULL AS [Directory Server]
    , CASE WHEN e.ID IS NOT NULL THEN e.Email ELSE t.Email END AS [E-mail Address]
    , NULL AS [E-mail Type]
    , NULL AS [E-mail Display Name]
    , NULL AS [E-mail 2 Address]
    , NULL AS [E-mail 2 Type]
    , NULL AS [E-mail 2 Display Name]
    , NULL AS [E-mail 3 Address]
    , NULL AS [E-mail 3 Type]
    , NULL AS [E-mail 3 Display Name]
    , NULL AS [Gender]
    , NULL AS [Government ID Number]
    , NULL AS [Hobby]
    , NULL AS [Home Address PO Box]
    , NULL AS [Initials]
    , NULL AS [Internet Free Busy]
    , NULL AS [Keywords]
    , NULL AS [Language]
    , NULL AS [Location]
    , NULL AS [Manager''s Name]
    , NULL AS [Mileage]
    , NULL AS [Notes]
    , NULL AS [Office Location]
    , NULL AS [Organizational ID Number]
    , NULL AS [Other Address PO Box]
    , NULL AS [Priority]
    , NULL AS [Private]
    , NULL AS [Profession]
    , NULL AS [Referred By]
    , NULL AS [Sensitivity]
    , NULL AS [Spouse]
    , c.ContactCategory AS [User 1]
    , NULL AS [User 2]
    , NULL AS [User 3]
    , NULL AS [User 4]
    , CASE WHEN w.ID IS NOT NULL THEN w.Website WHEN ws.Domain IS NOT NULL THEN ws.Website WHEN e.Email IS NULL THEN NULL ELSE 'www.' + LOWER(SUBSTRING(e.email, CHARINDEX('@', e.email) + 1, 255)) END AS [Web Page]
FROM
    (
        SELECT
            c.ID
            , l2.[Source] AS lSource
            , MIN(l2.SourceID) AS lSourceID
            , g2.[Source] AS gSource
            , MIN(g2.SourceID) AS gSourceID
            , MIN(s.SourceFirstName) AS FirstName
            , MIN(s.SourceLastName) AS LastName
            , MIN(s.SourceEmail) AS Email
            , MIN(s.SourceMobile) AS Mobile
            , MIN(s.SourcePhone) AS Phone
            , MIN(s.SourceCompany) AS Company
            , MIN(s.SourceJobTitle) AS JobTitle
            , MIN(s.SourceCountryCode) AS CountryCode
        FROM
            Contacts c
            LEFT OUTER JOIN SourceContactID l1 ON l1.ContactID = c.ID AND l1.[Source] = 'LinkedIn'
            LEFT OUTER JOIN SourceContacts l2 ON l2.[Source] = l1.[Source] AND l2.SourceID = l1.SourceID
            LEFT OUTER JOIN SourceContactID g1 ON g1.ContactID = c.ID AND g1.[Source] = 'GoogleCSV'
            LEFT OUTER JOIN SourceContacts g2 ON g2.[Source] = g1.[Source] AND g2.SourceID = g1.SourceID
            LEFT OUTER JOIN SourceContactID d ON d.ContactID = c.ID
            LEFT OUTER JOIN SourceContacts s ON s.[Source] = d.[Source] AND s.SourceID = d.SourceID
        GROUP BY
            c.ID
            , l2.[Source]
            , g2.[Source]
    ) t
    INNER JOIN Contacts c ON c.ID = t.ID

    LEFT OUTER JOIN ContactNames    n ON n.ID = c.ID
    LEFT OUTER JOIN ContactEmail    e ON e.ID = c.ID
    LEFT OUTER JOIN ContactMobile   m ON m.ID = c.ID
    LEFT OUTER JOIN ContactPhone    p ON p.ID = c.ID
    LEFT OUTER JOIN ContactCountry  r ON r.ID = c.ID
    LEFT OUTER JOIN ContactWebsite  w ON w.ID = c.ID
    LEFT OUTER JOIN ContactCompany  y ON y.ID = c.ID
    LEFT OUTER JOIN ContactJobTitle i ON i.ID = c.ID

    LEFT OUTER JOIN Websites ws ON ws.Domain = LOWER(SUBSTRING(e.email, CHARINDEX('@', e.email) + 1, 255))
    LEFT OUTER JOIN Countries rs ON rs.CountryCode = t.CountryCode

    LEFT OUTER JOIN SourceContacts l2 ON l2.[Source] = t.lSource AND l2.SourceID = t.lSourceID
    LEFT OUTER JOIN SourceContacts g2 ON g2.[Source] = t.gSource AND g2.SourceID = t.gSourceID
